/*	Version 13			*/
/* My routines as of DEC 24th 1990  27 Sept 1991 */

#include	<stdio.h>
#include	<math.h>
#include 	"nrutil.h"
#include 	<malloc.h>
#include <memory.h>
#include <stdlib.h>
#include <string.h>

FILE    *fopen(); 

#define INT(a) ( ((a) > 0.0) ? ( (int)((a)+0.5) ) : ( (int)((a)-0.5) ) ) 
#define MIN(a,b) ((a) < (b) ? (a) : (b) ) 
#define MAX(a,b) ((a) > (b) ? (a) : (b) ) 
#define	PI	3.14159
#define	STPI	2.50663 		/* sqrt ( 2*PI) */
#define	LTPI	1.83788 		/* log ( 2*PI) */
#define	FLUSH	fflush(stdout); 
#define fnewline fprintf(fp,"\n")
#define junkstring fscanf( fp, "%s", junk )
#define FNEWLINE fprintf(fp,"\n")
#define JUNKSTRING fscanf( fp, "%s", junk )

/* Functions in other files */

double	location_function();
double	func();
void 	fleg();
void 	fleg2();

/* Functions in r.c: */
/***    Index to Index   ***/

/* l_random */
/* basic input */ 
/* matrix allocation */
/* matrix construction */
/* output */
/* vectors */
/* vector operations */
/* input */
/* maths */
/* crash */
/* file handling routines */
/* silly functions */

/***    Index    ***/

/* list of functions that should be accepted from maths library */

double	drand48();
void 	srand48();
int 	abs(); 
double 	fabs(); 
double	exp();
double	sqrt(); 

/* my own functions */

/* l_random */

double 	l_random_1();
double 	l_random();
double 	gaussian();
double 	cheap_gaussian();
double 	gaussian01();
double 	gauss();
double 	robust_gauss();
double 	gauss_window();
double 	robust_z();
double	erfc();
double 	background();
double 	ran_back();
double 	randmr();
int 	l_random_bit();
int 	l_random_int();
int 	l_random_ud_bit();
double	flip1d();
double	flip2d();
void 	l_randomise();
void 	randomise();

/* basic input */ 

void	pause_for_return();
int 	yes_or_no();
int 	respond();

/* matrix allocation */

double 	***dmatrix3 ();
float 	***fmatrix3 ();
int 	***imatrix3 ();
int 	***ipyramid ();
double 	***dpyramid ();
unsigned char 	***cmatrix3 ();
unsigned char 	**cmatrix ();
void 	free_cmatrix();
double 	****dmatrix4 ();

/* matrix construction */
 
double 	constructdmatrixPOST ();
void 	postmultiplydmatrix ();
void 	premultiplydmatrix ();
void 	ppmultiplydmatrix ();
void 	addtodmatrix ();
void 	clipdmatrix ();
void 	invertdmatrix ();
void 	multiplydmatrix ();
void	constructfmatrix ();
void 	typeindmatrix ();	 
void 	enterdmatrix ();
double 	readindmatrix ();
void 	readinlumatrix ();
void 	dmatrixfromimatrix ();
void 	dmatrixfromdmatrix ();
void 	dmatrixfromcmatrix ();
void 	cmatrixfromdmatrix ();
void 	redistributedmatrix ();
int	readinimatrix ();
int	readincmatrix ();
void	dividecmatrix ();
void	multiplycmatrix ();
void	readincbmatrix ();
void 	randomdmatrix ();
void  	k2dmatrix();
void  	IJdmatrix();
void  	constantdmatrix();
void  	constantimatrix();
void  	constantcmatrix();
void 	readindmatrix3 ();
void 	randomisedmatrix3();
void 	constructaQa ();
void 	constructdmatrix ();
void 	lineardmatrix(); 
void 	toeplitzdmatrix(); 

/* output */

void 	printoutfvector();
void 	printoutivector();
void 	printoutimatrix ();
void 	printoutfmatrix ();
void 	printoutdmatrix ();/* printout is (w,n) 0,...,n-1 and has newline and is verbose */ /* except for printoutdmatrix(m,l1,h1,l2,h2,style) */
void 	writelumatrix ();
void 	writedmatrix ();
void    write_dvector_to();
void 	pr_cov_matrix ();
void 	displaydvector();	/* display is (w,m,n) and omits newline */
void 	dispdvector();	/* disp displays only very short numbers */
void 	pd(); 	/* prints a single double with a specified number of digits */ 
void 	pdv();	/* prints dvector without newline, with specified number of dogits */
void	piv();
void 	pi(); 	
void 	debug();
void 	debugf();
void 	debugd();
void 	newline(); 
void 	space();
#define fnewline fprintf(fp,"\n")
#define junkstring fscanf( fp, "%s", junk )

/* vectors */

void 	gaussianfvector();
void 	gaussiandvector();
void 	readinfvector();
/* void 	enterfvector(); */
void 	readinivector();
void 	enterdvector();
void 	readindvector();
double 	*readindvectorandsize();
void 	writedvectorandsize();
void 	writedvectorandsize_n();
void 	writedvectorandsize_conditional();
void 	writedvector();
void 	typeindvector();
void 	setdvectortoconst();
void 	setivectortoconst();
void 	dvectorfromdvector();
void 	copydvector();
void 	dvectortoslope();
void 	addtodvector();
void 	multiplydvector();
void 	l_randomdvector();
void 	randomdvector();
void 	printoutdvector();
void 	print2Ddvector();

/* vector operations */

float 	fdot();
double 	ddot();
double 	dmatrixsum();
double 	dmatrixsum2();
double	diagproduct();
void	leftimatrixmultiply();
void	rightimatrixmultiply();
void	leftdmatrixmultiply();
void	rightdmatrixmultiply();
void	reorderd();

/* input */

void 	inputf(); /* Two sorts of input: */
void 	inputd(); /* input-() inputs - */
void 	inputi(); /* and clears getchar for one digit only */
void 	inputrf(); /* Two sorts of input: */
void 	inputrd(); /* inputr-() inputs - */
void 	inputri(); /* and clears getchar up to next return */
void clearscan(); /* This clears getchar up to next return */

/* maths */

int	int_round();
double	double_round();
double	logfactorial();
double	factorial();
int	intin();
int	signdifff();
int	sgnf();
int	ipower();
double	dpower();
double	ddpower();
int	equald();

/* crash */

void	crash();
void	bleep();

/* file handling routines */

void 	read_qspec();
void 	generate_q();

/* silly functions */

double 	qfunction1();
double 	qfunction2();
double 	qfunction3();
void 	add_ca_and_printoutdmatrix();
void 	add_ca_todmatrix();

#define BIGNO_FOR_RAND ((double)(0x7fffffff) +1.0)
